#include <stdio.h>
#include <avr\io.h>
#include <avr\interrupt.h>

void delay_ms(uint16_t x);

//Aici initializezi timere in mod PWM
void PWM_Init2() {
   
    TCCR2 = (1<<WGM20) | (1<<WGM21);   			 // Set FastPWM mode
    TCCR2 |= (1<<COM21);               			 // Non-inverting mode
    TCCR2 |= (1<<CS22) | (1<<CS21) | (1<<CS20); 	 // 1024-factor prescaler
    OCR2 = 0x7F;
}



void PWM_Init1() {
   
    TCCR1A = (1<<WGM10); 		  	    //Set FastPWM mode
    TCCR1B = (1<<WGM12); 

    TCCR1A |= (1<<COM1A1) | (1<<COM1B1);       	    //Non-inverting mode
          
    TCCR1B |= (1<<CS12) | (1<<CS10);                //1024-factor prescaler
    OCR1A = 0x7F;
    OCR1B = 0x7F;

}



//Mai departe, te joci cu intensitatea de aici, modificand OCR2
void ModifyCompareValue2() {
    static unsigned char direction=5;
    unsigned char val;
    val=OCR2;
    if ( (val>=250) || (val<=0) ) direction=-direction;
    val+=direction;
    OCR2=val;
}


//Mai departe, te joci cu intensitatea de aici, modificand OCR2
void ModifyCompareValue1A() {
    static unsigned char direction=5;
    unsigned char val;
    val=OCR1A;
    if ( (val>=250) || (val<=0) ) direction=-direction;
    val+=direction;
    OCR1A=val;
}


//Mai departe, te joci cu intensitatea de aici, modificand OCR2
void ModifyCompareValue1B() {
    static unsigned char direction=5;
    unsigned char val;
    val=OCR1B;
    if ( (val>=250) || (val<=0) ) direction=-direction;
    val+=direction;
    OCR1B=val;
}



void delay_ms(uint16_t x)
{
  uint8_t y, z;
  for ( ; x > 0 ; x--){
    for ( y = 0 ; y < 90 ; y++){
      for ( z = 0 ; z < 6 ; z++){
        asm volatile ("nop");
      }
    }
  }
}


// initializarea convertorului analog digital
void ADC_init()
{
	// AVCC cu condesator pe AREF; PA7 ca input single ended; rezultat left-adjusted (8 biti de date)
	ADMUX = (1<<REFS0) | (1<<ADLAR) ;
	// activeaza ADC si intreruperea de conversie. Prescaler de ceas la maximum
	ADCSRA = (1<<ADEN) | (1<<ADIE) | (1<<ADPS2) | (1<<ADPS1) | (1<<ADPS0);
}
 
// intreruperea de conversie
SIGNAL(SIG_ADC)
{
	int data;

	data = ADCH;
	if (data>64) PORTD = 0x12;

}

// Functie ce trateaza trimiterea unui caracter pe seriala
int uart_putchar(char c, FILE *unused)      
{
	if (c == '\n')
		uart_putchar('\r', 0);
	loop_until_bit_is_set(UCSRA, UDRE);
	UDR = c;
	return 0;
}

// Functie ce trateaza primirea unui caracter pe seriala
int uart_getchar(FILE* f)
{
	char c;
    
    loop_until_bit_is_set(UCSRA, RXC);
    c = UDR;
    if(c=='\r')
		c='\n';
    uart_putchar(c,NULL); 
    return c;
}



int main() {

    DDRD  = 0xB2;
    PORTD = 0x82;
	
    PWM_Init2();
    PWM_Init1();
    ADC_init();

	while (1) {
			delay_ms(40);
			ModifyCompareValue2() ;
			delay_ms(20);
			ModifyCompareValue1A() ;
			delay_ms(50);
			ModifyCompareValue1B() ;
    }

    return 0;
}
